You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

88 lines
2.4 KiB

5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
  1. #!/bin/bash
  2. set -e
  3. exec 3>&1 # make stdout available as fd 3 for the result
  4. exec 1>&2 # redirect all output to stderr for logging
  5. echo "BUILD_ID: $BUILD_ID"
  6. echo "BUILD_NAME: $BUILD_NAME"
  7. echo "BUILD_JOB_NAME: $BUILD_JOB_NAME"
  8. echo "BUILD_PIPELINE_NAME: $BUILD_PIPELINE_NAME"
  9. # shellcheck disable=1090
  10. source "$(dirname $0)/common.sh"
  11. source=$1
  12. if [[ -z "$source" ]]; then
  13. echo "usage: $0 <path/to/source>"
  14. exit 1
  15. fi
  16. # for jq
  17. PATH=/usr/local/bin:$PATH
  18. payload=$(mktemp "$TMPDIR/rclone-resource-request.XXXXXX")
  19. cat > "$payload" <&0
  20. load_config "$payload"
  21. load_files "$payload"
  22. rclone_source_directory=$(jq -r '.params.source // ""' < "$payload")
  23. rclone_destinations=$(jq -r '.params.destination[]? | .dir // ""' < "$payload")
  24. if [[ -z "$rclone_source_directory" ]]; then
  25. echo "invalid source directory (missing source)"
  26. exit 1
  27. fi
  28. if [[ -z "$rclone_destinations" ]]; then
  29. echo "invalid destination (missing destination)"
  30. exit 1
  31. fi
  32. echo "Source directory: $rclone_source_directory"
  33. echo "Destinations:"
  34. jq -c '.params.destination[] | .dir' < "$payload"
  35. local_source_dir="${source}/${rclone_source_directory}"
  36. ls -alh "${local_source_dir}"
  37. sha256=$( (find "${local_source_dir}" -type f -exec sha256sum {} \;) | cut -d ' ' -f1 )
  38. echo "sha256:${sha256}"
  39. # Source is always the same for each destination
  40. rclone_source="local:${local_source_dir}"
  41. echo "Source: ${rclone_source}"
  42. destinations=$(jq -r '.params.destination[] | @base64' < "$payload")
  43. echo "Using encoded destinations:"
  44. echo " ${destinations}"
  45. for destination in $destinations; do
  46. _jq() {
  47. echo "${destination}" | base64 -d | jq -r "${1}"
  48. }
  49. rclone_destination=$(_jq '.dir')
  50. echo "Destination: $rclone_destination"
  51. rclone_destination_subdir_file=$(_jq '.subdir // ""')
  52. echo "Destination subdir file: ${rclone_destination_subdir_file}"
  53. rclone_destination_subdir=""
  54. if [ -n "$rclone_destination_subdir_file" ]; then
  55. echo "Looking in ${source}/${rclone_destination_subdir_file} for subdir to use"
  56. rclone_destination_subdir=$(head -n 1 < "${source}/${rclone_destination_subdir_file}")
  57. fi
  58. rclone_target="${rclone_destination}/${rclone_destination_subdir}"
  59. echo "Target: ${rclone_target}"
  60. rclone copy "${rclone_source}" "${rclone_target}" --config /opt/rclone/config/.rclone.conf --progress
  61. done
  62. jq -n "{
  63. version: {
  64. digest: $( (echo -n "sha256:"; echo "$sha256") | jq -R . )
  65. }
  66. }" >&3